p_STOP 		EQU 	0
pW_CHK_PATCH 	EQU	1
pB_CHK_PATCH 	EQU 	2	
pW_STORE	EQU 	4
pNotSupported 	EQU 	5	

cpm_biod_patcher:

	;dirty hasck
	;set jp 0 as first jp
	;strange dos behaviour,
	;sometime hangon when dir
	ld 	hl,0
	ld 	(BASE+1),hl 	;

	ld 	hl,msgPATCHER
	call 	PSTR

	ld 	de,bios_variants
chk_bios_lp:
	ld 	a,(de)
	ld 	l,a
	inc 	de
	ld 	a,(de)
	ld 	h,a
	inc 	de
	or 	l
	jp 	z,bios_not_found

	push 	de
	call 	try_bios
	pop 	de

	jp 	z,biod_found

	jp 	chk_bios_lp

; 	ld 	HL,_BIOS_21_89___wiza
; 	call 	try_bios
; 	jp 	z,found

; 	ld 	HL,_BIOS_12_88_3_alternativa
; 	call 	try_bios
; 	jp 	z,found

; 	ld 	HL,_BIOS_12_90_5_kontur
; 	call 	try_bios
; 	jp 	z,found

; 	ld 	HL,_BIOS_20_88___miks
; 	call 	try_bios
; 	jp 	z,found

; 	ld 	HL,_BIOS_21_89_2_niijaf
; 	call 	try_bios
; 	jp 	z,found

; 	ld 	HL,_BIOS_21_89_2_niijaf2
; 	call 	try_bios
; 	jp 	z,found

; 	ld 	HL,_BIOS_21_91___LAP
; 	call 	try_bios
; 	jp 	z,found

; 	ld 	HL,_BIOS_1x_88_EPSON_V104
; 	call 	try_bios
; 	jp 	z,found

; 	ld 	HL,_BIOS_1x_89_03_30_RAVI
; 	call 	try_bios
; 	jp 	z,found
	
; 	ld 	HL,_BIOS_12_87_09_NIIJAF
; 	call 	try_bios
; 	jp 	z,found

; 	ld 	HL,_BIOS_21m_____Shkanov
; 	call 	try_bios
; 	jp 	z,found

bios_not_found:
	ld 	hl,msgNOTFOUND
	call 	PSTR
	HALT

biod_found:
	push 	hl 		;bios name
	ld 	hl,msgFOUND
	call 	PSTR
	pop 	hl
	call 	PSTR
	ld 	hl,msgCRLF
	call 	PSTR

	ld 	a,(unsupported_flag)
	or 	a
	jp 	nz,bios_not_found

	ret

unsupported_flag:
	db 	0

msgPATCHER:
	db 	0dh,0ah,'BIOS PATCHER by ESL',0dh,0ah,0
msgFOUND:
	db 	'Found: ',0
msgNOTFOUND:
	db 	'Unsupported BIOS, use DEFAULT system instead.'
msgCRLF:
	db 	0dh,0ah,0


work_ptr:
	dw 	0;
patch_flag:
	db 	0
;     
;   HL   
;   HL    

try_bios:
	ld 	(work_ptr),hl

	;check
	xor 	a
	ld 	hl,(work_ptr)
	call 	do_patch
	ret nz


	;   

	ld 	hl,resident
	ld 	de,resident_addr
	ld 	bc,resident_len
	call	_p_ldir

	;patch
	ld 	a,1
	ld 	hl,(work_ptr)
	call 	do_patch

	xor 	a
	ret

do_patch:
	ld 	(patch_flag),a

patch_loop:

	ld 	a,(hl)
	inc 	hl

	cp 	p_STOP
	ret 	z 	;FOUND

	cp 	pB_CHK_PATCH
	jp 	nz,l_pW_CHK

	call 	fetch_dw_to_bc 	;BC addr
	push 	bc
	call 	fetch_db_to_b 	;b

	ex 	de,hl
	pop 	hl
	ld 	a,(hl)
	ex 	de,hl 		;de - addr

	ld 	c,b

	call 	fetch_db_to_b 	;b store

	cp 	c
	ret 	nz


	ld 	a,(patch_flag)
	or 	a
	jp 	z,patch_loop

	ex 	de,hl
	ld 	(hl),b
	ex 	de,hl
	jp 	patch_loop

l_pW_CHK:
	cp 	pW_CHK_PATCH
	jp 	nz,l_pW_STORE

	call 	fetch_dw_to_bc 	
	call 	store_bc_to_tmp

	call 	fetch_dw_to_bc 	;BC OLD value

	call 	read_de_at_tmp 	;de - value
	call 	cp_de_bc

	call 	fetch_dw_to_bc 	;bc NEW value

	ret 	nz

	ld 	a,(patch_flag)
	or 	a
	jp 	z,patch_loop

	call 	store_bc_at_tmp

	jp 	patch_loop

l_pW_STORE:
	cp 	pW_STORE
	jp 	nz,.pNotSupported


	call 	fetch_dw_to_bc 	;BC value
	push 	bc

	call 	fetch_dw_to_bc 	
	call 	store_bc_to_tmp

	pop 	bc

	ld 	a,(patch_flag)
	or 	a
	jp 	z,patch_loop

	call 	store_bc_at_tmp

	jp 	patch_loop

.pNotSupported:
	cp 	pNotSupported
	jp 	nz,.pHALT
	
	ld 	a,1
	ld 	(unsupported_flag),a
	jp 	patch_loop

.pHALT:
	ld 	hl,msg_InvalidPatchCode
	call 	PSTR

	halt

	ret
msg_InvalidPatchCode:
	db 	'Invalid patchcode, check registers',0dh,0ah,0

cp_de_bc:
	ld 	a,e
	cp 	c
	ret 	nz
	ld 	a,d
	cp 	b
	ret

tmp: 	dw 	0

;stor bc to tmp
store_bc_to_tmp:
	ld 	a,c
	ld 	(tmp),a

	ld 	a,b
	ld 	(tmp+1),a
	ret

store_bc_at_tmp:
	push 	hl
	ld 	hl,(tmp)
	ld 	(hl),c
	inc 	hl
	ld 	(hl),b
	pop 	hl
	ret

;de - value at (tmp)
read_de_at_tmp:
	push 	hl
	ld 	hl,(tmp)

	ld 	e,(hl)
	inc 	hl
	ld 	d,(hl)

	pop 	hl
	ret


fetch_dw_to_bc:
	ld 	c,(hl)
	inc 	hl
fetch_db_to_b:
	ld 	b,(hl)
	inc 	hl
	ret

_p_ldir:
	ld 	a,(hl)
	ld 	(de),a
	inc 	hl
	inc 	de
	dec 	bc
	ld 	a,c
	or 	b
	jp 	nz,_p_ldir
	ret


bios_variants:

	dw _BIOS_12_88_3_alternativa ;should be before _BIOS_12_88_3_niijaf because this is patched version
	dw _BIOS_12_88_3_niijaf      
	dw _BIOS_21_89___wiza	 
	dw _BIOS_21_89_2_niijaf2 	 
	dw _BIOS_21_89_2_niijaf   	 
	dw _BIOS_1x_89_03_30_RAVI    

	dw _BIOS_12_87_11_niijaf 	 
	dw _BIOS_12_90_5_kontur 	 
	dw _BIOS_20_88___miks 	 
	dw _BIOS_21_91___LAP 	 
	dw _BIOS_1x_88_EPSON_V104 	 
	dw _BIOS_12_87_09_NIIJAF     
	dw _BIOS_21m_____Shkanov 	 

	dw _CPM_NET_KORNET_drive_a  
	dw _CPM_NET_KORNET_drive_b  
	dw _CPM_NET_SFERA1 	 
	dw _CPM_NET_SFERA2 	 

	dw _MICRODOS_1_861011 	 
	dw _MICRODOS_1_861115	 
	dw _MICRODOS_1_870430 	 
	dw _MICRODOS_1_871220 	 
	dw _MICRODOS_2_880630   
	dw _MICRODOS_2_900105 	 

	dw 	0


	db 	"PARCHER DATA>>"
	include	"extrom-patcher-12_88_3_alternativa.asm" ;  25
	include	"extrom-patcher-12_88_3_niijaf.asm"      ;  78
	include "extrom-patcher-21_89___wiza.asm"	 ;  42
	include	"extrom-patcher-21_89_2_niijaf2.asm" 	 ;  36
	include	"extrom-patcher-21_89_2_niijaf.asm"   	 ;  28
	include	"extrom-patcher-1x_89_03_30_RAVI.asm"    ;  17

	include	"extrom-patcher-12_87_11_niijaf.asm" 	 ;   3
	include	"extrom-patcher-12_90_5_kontur.asm" 	 ;   4
	include	"extrom-patcher-20_88___miks.asm" 	 ;   4
	include	"extrom-patcher-21_91___LAP.asm" 	 ;   4
	include	"extrom-patcher-1x_88_EPSON_V104.asm" 	 ;   1
	include	"extrom-patcher-12_87_09_NIIJAF.asm"     ;   2
	include	"extrom-patcher-21m_____Shkanov.asm" 	 ;   2

	include	"extrom-patcher-NET_KORNET_drive_a.asm"  ;   2
	include	"extrom-patcher-NET_KORNET_drive_b.asm"  ;   2
	include	"extrom-patcher-NET_SFERA1.asm" 	 ;   2
	include	"extrom-patcher-NET_SFERA2.asm" 	 ;   1

	include	"extrom-patcher-MICRODOS_1_861011.asm" 	 ;   7
	include	"extrom-patcher-MICRODOS_1_861115.asm"	 ;   2
	include	"extrom-patcher-MICRODOS_1_870430.asm" 	 ;  28
	include	"extrom-patcher-MICRODOS_1_871220.asm" 	 ;   2
	include	"extrom-patcher-MICRODOS_2_880630.asm"   ;  42
	include	"extrom-patcher-MICRODOS_2_900105.asm" 	 ;   4

	db 0xff
resident:
	include "extrom-patcher-resident.asm"
resident_len 	equ $-resident
	db "RESIDENT LEN>"
	dw resident_len
	db "<"
