;==================   ExtROM-API ====================================
	
PORTA	EQU	0FB08H		;   A  
PORTC	EQU	0FB0AH		;     
PCWR	EQU	0FB0BH		;   
	
;****************************************
;*            *
;****************************************
EXR_GETBYTE:
	PUSH	HL
	LD	HL,PORTC
WG:
	LD	A,(HL)		;   55 -    
	AND	20h		;   IBF
	JP	Z,WG		; IBF=0 -   
	LD	A,(PORTA)		;   -     
	POP	HL
	RET

;****************************************
;*      A             *
;****************************************
EXR_PUTBYTE:
	PUSH	HL
	PUSH	AF
	LD	HL,PORTC
WP:
	LD	A,(HL)		;   55 -    
	AND	80h		;   -OBF
	JP	Z,WP		; -OBF=0 -     
	POP	AF
	LD	(PORTA),A		;   -     
	POP	HL
	RET

;*******************************************
;*                             *
;* HL -       *
;*    - 128               *
;*******************************************
EXR_GETSEC:
	PUSH	BC
	PUSH	DE
	LD	C,128		;   ,  128 
	EX	DE,HL		;   -> DE
	LD	HL,PORTC
GSL:
	LD	A,(HL)		;   55 -    
	AND	20h		;   IBF
	JP	Z,GSL		; IBF=0 -   
	LD	A,(PORTA)		;   -     
	LD	(DE),A		;     
	INC	DE		;   ++
	DEC	C		;   
	JP	NZ,GSL
	POP	DE
	POP	BC
	RET

;*******************************************
;*                          *
;* HL -       *
;*    - 128               *
;*******************************************
EXR_PUTSEC:
	PUSH	BC
	PUSH	DE
	LD	C,128		;   ,  128 
	EX	DE,HL		;   -> DE
	LD	HL,PORTC
PSL:
	LD	A,(HL)		;   55 -    
	AND	80h		;   -OBF
	JP	Z,PSL		; -OBF=0 -     
	LD	A,(DE)		;     
	LD	(PORTA),A		;   -     
	INC	DE
	DEC	C		;   
	JP	NZ,PSL
	POP	DE
	POP	BC
	RET

;****************************************
;*              *
;****************************************
EXR_SENDCMD:

	PUSH	HL
	PUSH	BC
	LD	A,0Ch
	LD	(PCWR),A	;     2
	LD	HL,EXR_CMD
	LD	C,4		;  - 4 
	LD	B,0		;   
SCL:
	LD	A,(HL)		;    
	ADD 	B		;   
	LD	B,A
	LD	A,(HL)		;    
	CALL	EXR_PUTBYTE		; -  
	INC	HL
	DEC	C
	JP	NZ,SCL
	LD	A,B
	DEC 	A		; -1
	CALL	EXR_PUTBYTE     ;  
	CALL	EXR_GETBYTE	;  
	POP	BC
	POP	HL
	RET

;*******************************************
;*    
;*******************************************
EXR_READINFO:
	LD	HL,EXR_CMD	;  
	LD	(HL),1		;  
	INC	HL
	LD	A,(DSKCPM)	;  # 
	LD	(HL),A
	INC	HL
	LD	(HL),0		; ,    0  0 
	INC	HL
	LD	(HL),0		
	CALL	EXR_SENDCMD	;  
	OR	A
	RET 	Z		; 
	LD	HL,RRBUFF	;  
	CALL	EXR_GETSEC
	LD	A,1
	RET


;    Extrom-API
;===============================================
EXR_CMD:	DB	0	;  (0)-(1)
EXR_DRV:	DB	0	;  - A(0), B(1)	
EXR_TRK:	DB	0	;  
EXR_SEC:	DB	0	;   (128b)
