API_GET_MOUNT_NAME	EQU	0x80
API_GET_MOUNT_STATUS 	EQU	0x82

; x123:
; 	db 0dh,0ah
; 	db '0         1         2         3         4         5         6   '
; 	db '0123456789012345678901234567890123456789012345678901234567890123'
; 	db 0
show_mount_info:

	ld 	hl,msg_default_mount
	call 	PSTR

	ld 	a,0
	call 	show_mount_drive

	ld 	a,1
	call 	show_mount_drive

	ld 	a,2
	call 	show_mount_drive

	ld 	a,3
	call 	show_mount_drive

	ld 	hl,mount_crlf
	call 	PSTR

	ret

show_mount_drive:
	ld 	(DRV),a

	add 	a,'A'
	ld 	(mount_msg_drv),a

	call 	get_mount_info

	ld 	hl,mount_msg
	call 	PSTR

	ld 	bc,'RW'
	ld 	a,(mount_buf)
	or 	a
	ld 	a,c
	jp 	nz,.rw
	ld 	a,b
.rw:
	call 	PUTCH
	ld 	a,' '
	call 	PUTCH

	call 	prepare_name
	
	ld 	hl,mount_msg_path
	call 	PSTR

; 	ld 	hl,mount_crlf
; 	call 	PSTR

	ret


prepare_name:
	ld 	de,mount_msg_path
	ld 	c,32-3-1-1

	ld 	hl,mount_buf+1
	call 	copy_z
	
	ld 	a,'/'
	ld 	(de),a
	inc 	de

	ld 	hl,mount_buf+1+14
	call 	copy_z

	ld 	a,c
	or 	a
	jp 	z,no_fill

	ld 	a,' '
.fill:
	ld 	(de),a
	inc 	de
	dec 	c
	jp 	nz,.fill

no_fill:
	xor 	a
	ld 	(de),a
	ret

copy_z:
	ld 	a,c
	or 	a
	ret 	z

	ld 	a,(hl)
	or 	a
	ret 	z

	ld 	(de),a
	inc 	hl
	inc 	de
	dec 	c
	jp 	copy_z

get_mount_info:
	ld 	a,API_GET_MOUNT_NAME
	ld 	(CMD),a
	call 	SENDCMD

	ld 	c,29

receive_c_bytes_to_hl:

	ld 	hl,mount_buf
get_lp:
	call 	GETBYTE
	ld 	(HL),a
	inc 	hl
	dec 	c
	jp 	nz,get_lp
	ret

;GETBYTE:
; 	PUSH	HL
; 	LD	HL,PORTC
; WG:
; 	LD	A,(HL)		; слово состояния ВВ55 - берется из порта С
; 	AND	20h		; выделяем сигнал IBF
; 	JP	Z,WG		; IBF=0 - данных еще нет
; 	DEC	L
; 	DEC	L
; 	LD	A,(HL)		; данные поступили - выбираем их из порта А
; 	POP	HL
; 	RET


msg_default_mount:
		db 	'Default EXTROM mount:',0dh,0ah,0
mount_msg:	
mount_msg_drv: 	db 	'A:'
		db 	0
mount_msg_path:
		ds 	32


mount_buf: 	
		db 	0 			;=1 if R/O
		db 	'              ' 	;Folder 14 asciiZ 
		db 	'              ' 	;Name   14 asciiZ
		db 	0

mount_crlf: 	db 	0dh,0ah,0	

; CMD:	DB	1		; Команда чтения
; DRV:	DB	0
; TRK:	DB	0
; SEC:	DB	0


; 80 — получить имя образа

; Команда предназначена для получения имени KDI-файла, смонтированного в данный момент на логическом устройстве A-D.  
;  Номер устройства задается в поле DRV. Возвращается буфер размером 29 байт, содержащий следующую информацию:

; 1 байт флага разрешение записи (0 — чтение/запись, 1 — только чтение)
; 14-байтовый буфер с именем каталога, из которого смонтирован файл образа, заканчивающийся 0.
; 14-байтовый буфер с именем файла, заканчивающийся 0.

; 82 — проверка состояния устройства
; 	Команда возвращает ответ ОК, если устройство смонтировано, или Fail, если не смонтировано. 
; Флаг состояния автоматически опускается в случае ошибок ввода-вывода на данном устройстве. 
; С помощью этой команды можно проверить результат предыдущего вызова mount (81)
