/*
 * AUTHOR: Sergey Erokhin                 esl@pisem.net,pk8020@gmail.com
 * &Korvet Team                                              2000...2005
 * ETALON Korvet Emulator                         http://pk8020.narod.ru
 * ---------------------------------------------------------------------
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
 *
 */
#include <allegro.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/stat.h> /* for mode definitions */
#include <ctype.h>

#include <sys/poll.h>
#include <unistd.h>
#include <signal.h>
#include <asm-generic/ioctls.h>
#include <termios.h>

#ifndef _KORVET_H
#define _KORVET_H

#ifdef __GNUC__
/*code for GNU C compiler */
#elif _MSC_VER
/*usually has the version number in _MSC_VER*/
/*code specific to MSVC compiler*/
#elif __BORLANDC__
/*code specific to borland compilers*/
#elif __MINGW32__
/*code specific to mingw compilers*/
#endif


#define LAN_SUPPORT

#define DBG
#define noEGA
#define SOUND
#define noWAV
#define noTRACETIMER

#define RAMSIZE         (64*1024)

#define PLANESIZE 	16384


#define OK 		0
#define ERROR		1

#define CPU_CLK         2500000    // частота ЦПУ в герцах
#define ALL_TAKT        50000      // кол-во тактов в одном VBLANK
#define VBLANK_TAKT     8170       // кол-во тактов обрптного хода луча

#define KBD_QWERTY	0
#define KBD_JCUKEN	1
#define KBD_AUTO	2

#define SCR_EMULATOR	1
#define SCR_DBG		2

#define SOUNDFREQ (44100/2)
#define AUDIO_BUFFER_SIZE (SOUNDFREQ/50)

#define MAXBUF 50000 	//audio buffer size

#define LUT_BASE_COLOR 0x80


#ifndef _TYPEDEF_
typedef unsigned char  byte;
typedef unsigned short word;
typedef unsigned       dword;
typedef signed char    offset;
#define _TYPEDEF_
#endif

void Emulator_Write(int Addres,byte Value);
byte Emulator_Read(int Addres);

void FDC_Write_DRVREG(byte Value);
void FDC_Write(int Addr, byte Value);
byte FDC_Read(int Addr);

int  KEYBOARD_Read(int Addr,int InternalMode);

void GZU_Write(int Addr,byte Value);
byte GZU_Read(int Addr);

void ACZU_Write(int Addr,byte Value);
byte ACZU_Read(int Addr);

void LUT_Write(byte Value);

byte PIC_Read(int Addr);
void PIC_Write(int Addr,byte Value);

void PIC_IntRequest(int IntNum);             // Запрос на прерывание.


void PPI1_Write(int Addr, byte Value);
byte PPI1_Read(int Addr);

void PPI2_Write(int Addr, byte Value);
byte PPI2_Read(int Addr);

void PPI3_Write(int Addr, byte Value);
byte PPI3_Read(int Addr);

void PPI_init();

void RS232_Write(int Addr, byte Value);
byte RS232_Read(int Addr);

void Timer_Write(int Addr, byte Value);
byte Timer_Read(int Addr);

void update_rus_lat(void);
void ResetOSD(void);

#endif

